//+------------------------------------------------------------------+
//|                                                        Filer.mqh |
//|                                                        AdvisorTC |
//|                                              http://AdvisorTC.ru |
//+------------------------------------------------------------------+
#property copyright "AdvisorTC"
#property link      "http://AdvisorTC.ru"
#property version   "1.2"
#property description "    "
#property strict
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CFiler
  {
private:

public:
                     CFiler();
                    ~CFiler();
   bool              StringToFile(string fileName,string text,bool isReWrite);
   string            FileToString(string fileName,int delim=';');
   void              FileToStringArray(string fileName,string &result[],int delim=';');
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CFiler::CFiler()
  {
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CFiler::~CFiler()
  {
  }
//+------------------------------------------------------------------+

//+--------------------------------------------------------------1.1-+
//|                                                 |
//|   fileName -                               |
//|   text     -                                    |
//|                                                                  |
//|  TRUE                                     |
//+------------------------------------------------------------------+
bool CFiler::StringToFile(string fileName,//     
                          string text,//   
                          bool isReWrite=false //  (false)   (true)
                          )
  {
   bool b=FileIsExist(fileName);
   if(isReWrite && FileIsExist(fileName))
     {
      b=FileDelete(fileName);

     }

   int file_handle=FileOpen(fileName,FILE_READ|FILE_WRITE|FILE_ANSI," ");

   if(file_handle>0)
     {
      FileSeek(file_handle,0,SEEK_END);
      FileWriteString(file_handle,text); //FileWrite(file_handle,text)
      FileClose(file_handle);
     }
   else { return(false); }

   return(true);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|      string                             |
//|   fileName -                                    |
//|                                                                  |
//|      string                     |
//+------------------------------------------------------------------+
string CFiler::FileToString(string fileName,int delim=';')
  {
   int handle;
   string str="";
   string result="";
   handle=FileOpen(fileName,FILE_READ|FILE_CSV,delim);

   if(handle>0)
     {
      while(true)
        {
         str=FileReadString(handle);

         if(str=="") { break; }
         else
           {
            result=result+str+"\n";
           }// <- else
        }// <- while  

      FileClose(handle);
     }

   return(result);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|       string                      |
//|   fileName -                                    |
//|                                                                  |
//|      string                     |
//+------------------------------------------------------------------+
void CFiler::FileToStringArray(string fileName,string &result[],int delim=';')
  {
   int handle;
   string str="";
   ArrayFree(result);

   handle=FileOpen(fileName,FILE_READ|FILE_CSV,delim);

   if(handle>0)
     {
      while(true)
        {
         str=FileReadString(handle);
         StringReplace(str,"\n","");
         StringReplace(str,"\t","");
         StringReplace(str,"\r\n","");
         if(str=="") { break; }
         else
           {
            ArrayResize(result,ArraySize(result)+1);

            result[ArraySize(result)-1]=str;
           }// <- else
        }// <- while  

      FileClose(handle);
     }

  }
//+------------------------------------------------------------------+
